<template>
  <div
    ref="component"
    class="LibsTab _tabcontent">
    <tab-simple
      v-model="items"
      :is-tab-active="isTabActive"
      :item-title="'L: open folder, R: open in sublime'"
      @leftClick="leftClick"
      @rightClick="rightClick"
      @middleClick="middleClick"
      @create="createItem"
      @onTabActive="onTabActive"
      tab-name="libs"
      single-item="lib">
      <template slot="controls" slot-scope="prop">
        <i
          @click="$message('drag lib outside')"
          v-if="isLibDraggable"
          :draggable="isLibDraggable"
          class="fa fa-file-code-o"
          aria-hidden="true"
          title="drag lib outside">
        </i>
        <i @click="copyPath(prop.item)" class="fa fa-clone" aria-hidden="true" title="copy path"></i>
        <i @click="renameItem(prop.item)" class="fa fa-pencil-square-o" aria-hidden="true" title="rename item"></i>
        <i @click="deleteItem(prop.item)" class="fa fa-trash" aria-hidden="true" title="delete item"></i>
      </template>
    </tab-simple>
    <el-dialog
      class="CopyLibFilesDialog"
      title="Copy lib file"
      :visible.sync="copyLibNamePopup">
      <div
        class="_libItem"
        v-for="(file, index) in copyLibItems"
        :key="index">
        <span
          class="_libItemName"
          @click="copyFileToClipboard(copyLib, file)">
          {{ file }}
        </span>
        <span class="_libItemFile">
          <i
            v-if="isLibDraggable"
            :draggable="isLibDraggable"
            @click="$message('drag file outside')"
            class="fa fa-file-code-o"
            aria-hidden="true">
          </i>
        </span>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import TabSimple from '@/components/ui/TabBar/TabSimple/TabSimple'

export default {
  components: {
    TabSimple
  },
  data() {
    return {
      items: [],
      copyLibNamePopup: false,
      copyLibItems: [],
      copyLib: null,
      isLibDraggable: false,
    }
  },
  computed: {
    isTabActive() {
      return this.$parent.active
    },
  },
  mounted() {
    if (this.isTabActive) {
      this.onTabActive()
    }
    if (process.client) {
      this.isLibDraggable = os.platform() === 'win32' || os.platform() === 'darwin'
      if (this.isLibDraggable) {
        document.addEventListener('dragend', this.handleDragOutside)
      }
    }
  },
  beforeDestroy() {
    if (this.isLibDraggable) {
      document.removeEventListener('dragend', this.handleDragOutside)
    }
  },
  methods: {
    async onTabActive() {
      if (!this.items.length) {
        const { data } = await this.$axios.get(`/libs/get`)
        this.items = data
      }
    },
    async handleDragOutside(e) {
      const { stdout: targetDir } = await currentPath()
      if ($(e.target).closest('._item').length) {
        // LIB
        const libName = $(e.target).closest('._item').find('.name').text().trim()
        const localLibPath = path.join(sourcesDir, 'libs', libName)
        const targetLibPath = path.join(targetDir, libName.split('_')[0])
        try {
          fs.copySync(localLibPath, targetLibPath)
        } catch (err) {
          console.log(err)
        }
      } else {
        // FILE
        const localFileName = $(e.target).closest('._libItem').text().trim()
        const localFilePath = path.join(sourcesDir, 'libs', this.copyLib.name, localFileName)
        const targetFilePath = path.join(targetDir, localFileName)
        try {
          fs.copySync(localFilePath, targetFilePath)
        } catch (err) {
          console.log(err)
        }
      }
    },
    leftClick(item) {
      const libsPath = path.join(os.homedir(), 'one-punch-web', 'sources', 'libs')
      open(path.join(libsPath, item.name))
      win.close()
    },
    rightClick(item) {
      this.openInSublime(item)
      win.close()
    },
    middleClick(item) {
      this.openInSublime(item)
    },
    openInSublime(item) {
      const libsPath = path.join(os.homedir(), 'one-punch-web', 'sources', 'libs')
      const targetLibPath = path.join(libsPath, item.name)
      const command = os.platform() !== 'win32'
        ? `cd "${targetLibPath}" && subl .`
        : `cd /d "${targetLibPath}" && subl . && exit`
      cmd.run(command)
    },
    copyPath(item) {
      const libItemPath = path.join(os.homedir(), 'one-punch-web', 'sources', 'libs', `${item.name}`)
      const files = fs.readdirSync(libItemPath).filter(file => file !== `${item.name}.png`)
      const noFiles = () => this.$message('Lib dir is empty')
      const multipleFiles = () => {
        this.copyLibItems = files
        this.copyLib = item
        this.copyLibNamePopup = true
      }
      !files.length
        ? noFiles()
        : files.length === 1
          ? this.copyFileToClipboard(item, files[0])
          : multipleFiles()
    },
    copyFileToClipboard(item, file) {
      const clipboard = nw.Clipboard.get()
      const text = `${item.name.split('_')[0]}/${file}`
      clipboard.set(text, 'text')
      this.$axios.post('/notify', {
        text: text,
        title: 'copied to clipboard',
        icon: 'success.png',
      })
      this.$message('Lib copied to clipboard')
    },
    createItem() {
      this.$prompt(`Create lib`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|]+$/,
        inputErrorMessage: 'Invalid lib name'
      }).then(async (data) => {
        const libName = data.value
        const libsPath = path.join(os.homedir(), 'one-punch-web', 'sources', 'libs')
        const libPngPath =  path.join(libsPath, libName, `${libName}.png`)
        fs.ensureDirSync(path.join(libsPath, libName))
        open(path.join(libsPath, libName))
        win.close()
      }).catch(e => {
        console.log(e)
      })
    },
    renameItem(item) {
      this.$prompt(`Rename "${item.name}" lib to:`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|]+$/,
        inputErrorMessage: 'Invalid lib name'
      }).then(async (data) => {
        const newLibName = data.value
        if (newLibName && newLibName !== item.name) {
          await this.$axios.post(`/libs/rename/${item.name}`, {
            newName: data.value
          })
          const index = _.findIndex(this.items, { name: item.name })
          this.items.splice(index, 1, { name: newLibName })
        }
      }).catch(e => {})
    },
    deleteItem(item) {
      this.$confirm(`Delete lib ${item.name}. Continue?`, 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(async () => {
        await this.$axios.post(`/libs/delete/${item.name}`)
        const index = _.findIndex(this.items, { name: item.name })
        this.items.splice(index, 1)
      })
    },
  }
}
</script>

<style lang="less" scoped>
@import "./LibsTab.less";
</style>